from PyQt5 import QtWidgets, QtCore


class CrossSection:
    length = 0
    pixelVal = []
    x = []
    y = []
    line = QtWidgets.QGraphicsLineItem()
    originalLine = QtWidgets.QGraphicsLineItem()
    originalCoords = []
    xAxis = []

    def __init__(self, item, scale):
        self.line = item
        self.x = list(self.x)
        self.y = list(self.y)
        self.xAxis = list(self.xAxis)
        self.x = [self.line.line().x1(), self.line.line().x2()]
        self.y = [self.line.line().y1(), self.line.line().y2()]
        self.length = self.line.line().length()
        self.pixelVal = list(self.pixelVal)
        self.initializeOriginalCoords(scale)
        self.initializeOriLine()

# getters +++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
    def getLine(self):
        return self.line

    def getX(self):
        return self.x

    def getY(self):
        return self.y

    def getLength(self):
        return self.length

    def getPixelValLen(self):
        return len(self.pixelVal)

    def getPixelValLenAt(self, i):
        return len(self.pixelVal[i])

    def getPixelVal(self):
        return self.pixelVal

    def getPixelValAt(self, i):
        return self.pixelVal[i]

    def getX(self):
        return self.x

    def getxAxis(self):
        return self.xAxis

    def getOriginalCoord(self):
        return self.originalCoords

    def getOriginalLine(self):
        return self.originalLine

# appends+++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
    def initializeOriginalCoords(self, scale):
        self.originalCoords = list(self.originalCoords)
        self.originalCoords.append(QtCore.QPoint(self.x[0] * (1/scale), self.y[0] * (1/scale)))
        self.originalCoords.append(QtCore.QPoint(self.x[1] * (1/scale), self.y[1] * (1/scale)))

    def initializeOriLine(self):
        self.originalLine = QtWidgets.QGraphicsLineItem(self.originalCoords[0].x(), self.originalCoords[0].y(),
                                                        self.originalCoords[1].x(), self.originalCoords[1].y())

    def appendPixelVal(self, p):
        self.pixelVal.append(p)

    def appendxAxis(self, x):
        self.xAxis.append(x)
